' See PMMVGD_NTSC_HDR.INC for descriptions
'
' DO NOT EDIT THIS FILE UNLESS YOU REALLY KNOW WHAT YOU ARE DOING !!!
'
IntHandler:

  intFlag = 0           ' (1)
  ASM
    ' Preserve __PARAM1
    MOV FSR,#__INTPARAMFSR ' (2)
    MOV IND,__PARAM1    ' (2)
    ' Generate Sync level video
    AND AVPort,#$F0     ' (2) Video = sync level, audio unchanged

    ' Check if audio pin needs to be toggled
CheckTone:
    MOV FSR,#sndToneCnt ' (2)
    DEC IND             ' (1) Adjust count
    JNZ WaitVModeBranch ' (2/4)
    MOV FSR,#sndVol     ' (2)
    XOR AVPort,IND      ' (2)
    MOV FSR,#sndTone    ' (2)
    MOV __PARAM1,IND    ' (2)
    MOV FSR,#sndToneCnt ' (2)
    MOV IND,__PARAM1    ' (2)
    JMP VModeBranch     ' (3) Jump to handle VMode duties

WaitVModeBranch: ' (9)
    JMP $+1               ' (3)
    JMP $+1               ' (3)
    JMP $+1               ' (3)
    JMP $+1               ' (3)
    NOP                   ' (1)  

VModeBranch: '(22 to get here)
  ' Handle video duties (BRANCH takes different number of cycles)
  ' MAKE SURE THIS CODE IS IN THE TOP HALF OF A CODE PAGE !!!
    MOV FSR,#vidMode
    MOV W,VidMode   ' Get current VidMode
    BANK $00
    JMP PC+W        ' Jump 
    JMP VSync       ' VidMode=0, Do vertical sync
    JMP TopBlank    ' VidMode=1, Do top blank lines
    JMP Video       ' VidMode=2, Display tiles
    JMP BotBlank    ' VidMode=3, Do bottom blank lines
  ENDASM

' -------------------------------------------------------------------------
' Interrupt Subroutines
' -------------------------------------------------------------------------
'  INTERRUPT SUBROUTINES
'
PrimeTileDots: ' Get tiledots for NEXT tile to be generated
  ASM
    CLC                      ' (1) Clear carry   
    MOV W,>>tileAddr         ' (1) Get tileAddr / 2
    AND W,#$0F               ' (1) Mask off high 4 bits
    MOV __PARAM1,W           ' (1) Store in __PARAM1
    MOV W,tileAddr           ' (1) Get tileAddr
    AND W,#$E0               ' (1) Mask off lower 5 bits
    OR W,__PARAM1            ' (1) Add __PARAM1
    MOV FSR,W                ' (1) Save value in FSR
    SETB FSR.4               ' (1) Set bit 4 or saved value
    MOV __PARAM1,IND         ' (2)  and put in __PARAM1
    BANK $00                 ' (1) Reset bank

    ' __PARAM1 now holds the byte from the video array
    SNB tileAddr.0           ' (1) If doing even tile, skip swap
    SWAP __PARAM1            ' (1) Swap if doing odd tile  
    AND __PARAM1,#$F0        ' (2) 

    ' __PARAM1 now holds the nibble value of the tile we want
    MOV W,#$D0               ' (1) See if we are on on the first video line
  ENDASM
'{$IFDEF TILESETS_1}
  \ CLC
'{$ELSE}
  \ADD W,tileAddr            ' (1) Cause a carry if NOT first line
'{$ENDIF}
  ASM
    RR __PARAM1              ' (1) If first line a zero will shift in, otherwise a 1 will shift in
    MOV W,#$2                ' (1) Tile patterns are at $200
    MOV M,W                  ' (1)
    MOV W,__PARAM1           ' (1)
    ADD W,vidTileLine        ' (1)
    IREAD                    ' (4) Get tile bit pattern from DATA table
    MOV tileDots,W           ' (1) Store bit pattern
  ENDASM                     ' (20)    (33) TOTAL 
  RETURN

WasteTime:
  ASM
    IREAD                    ' (4) Waste time
    IREAD                    ' (4) Waste time
    IREAD                    ' (4) Waste time
  ENDASM
  RETURN  

VSync: ' Just stay at sync level for vsync signal
  DEC vidCnt
  IF vidCnt <> 0 THEN IntDone ' Adjust vertical count, and if not zero we're done
  IF SndDurCnt <> 0 THEN     ' If bell if NOT active, jump to NoBell
    DEC sndDurCnt
    IF sndDurCnt <> 0 THEN MoreBell ' Adjust bellcnt and jump to MoreBell if still active
    AVPort = AVPort AND 15   ' Make audio pin low when no bell is active
    sndVol = 0               ' Make volume zero
  ENDIF

MoreBell:
  ' Setup for TopBlank Lines
  INC vidMode                ' Set VidMode to TopBlank
  vidCnt = TOP_BORDER        ' Generate 40 blank lines
  GOTO IntDone               ' Do end of video line checks

TopBlank:
  VideoPause                 ' HSync for 4.7usec
  AVBlack = 1                ' Video = Black level
  DEC vidCnt
  IF vidCnt <> 0 THEN IntDone
  ' Done with TopBlank lines, setup for Active video
  INC vidMode                ' Set VidMode to Video
  tileAddr = $20             ' RAM address of 1st tile
  vidTileLine = 0            ' Current line within 1 tile
  vidLineRpt = LINE_REPT     ' Prime VidLineRpt count
  PrimeTileDots              ' Setup tiledots
  GOTO IntDone               ' Do end of video line checks

Video:
  VideoPause                 ' HSync for 4.7usec
  AVBlack = 1                ' Black level
  \MOV __PARAM1,#LEFT_BDR    ' Black for left border
  \DJNZ __PARAM1,@$
  ' Do one line of video output

NextTile:
  ' Outputs one line of 8 video pixels. Uses the time between pixels to
  '  read tile dot data for character at (tileAddr)*8+vidTilerCnt to get
  '  the next 8 pixels ready.
  ' There must be 24 cycles per dot
  ASM
    MOVB AVWhite,tileDots.7 ' (4) Bit 7
    INC tileAddr             ' (1)
    CLC                      ' (1)
    MOV W,>>tileAddr         ' (1)
    AND W,#$0F               ' (1)
    MOV __PARAM1,W           ' (1)
    MOV W,tileAddr           ' (1)
    AND W,#$E0               ' (1)
    OR W,__PARAM1            ' (1)
    MOV FSR,W                ' (1)
    SETB FSR.4               ' (1)
    MOV W,IND                ' (1)
    MOV __PARAM1,W           ' (1)  and put in __PARAM1
    BANK $00                 ' (1)
    SNB tileAddr.0           ' (1)
    SWAP __PARAM1            ' (1)
    MOV W,#$F0               ' (1)
    AND __PARAM1,W           ' (1)
    MOV W,#$D0               ' (1)
  ENDASM
'{$IFDEF TILESETS_1}
  \ CLC
'{$ELSE}
  \ADD W,tileAddr            ' (1) Cause a carry if NOT first line
'{$ENDIF}
  ASM
    RR __PARAM1              ' (1)
    MOVB AVWhite,tileDots.6  ' (4) Bit 6
    CALL WasteTime
    MOVB AVWhite,tileDots.5  ' (4) Bit 5
    CALL WasteTime
    MOVB AVWhite,tileDots.4  ' (4) Bit 4
    CALL WasteTime
    MOVB AVWhite,tileDots.3  ' (4) Bit 3
    CALL WasteTime
    MOVB AVWhite,tileDots.2  ' (4) Bit 2
    CALL WasteTime
    MOVB AVWhite,tileDots.1  ' (4) Bit 1
    CALL WasteTime
    MOVB AVWhite,tileDots.0  ' (4) Bit 0
    IREAD                    ' (4) Waste time
    MOV M,#$2                ' (1) Tile patterns are at $200
    MOV W,__PARAM1           ' (1)
    ADD W,vidTileLine        ' (1)
    IREAD                    ' (4) Get tile bit pattern from DATA table
    MOV tileDots,W           ' (1) Store bit pattern
    MOV __PARAM1,tileAddr    ' (2) Check of end of line
    MOV W,#$0F               ' (1)
    AND __PARAM1,W           ' (1)
    JNZ NextTile             ' (2/4) If not end of line, do next tile
  ENDASM
  AVWhite = 0                ' Black level for rest of line
  ' Setup for next line
  tileAddr=tileAddr - 16     ' Adjust tileAddr to start of SAME line
  DEC vidLineRpt
  IF vidLineRpt <> 0 THEN Prime' If not last repeated line, jump to Prime
  ' Setup for NEXT tile line
  vidLineRpt = LINE_REPT
  INC vidTileLine            ' Move to next vertical line within tile
  IF vidTileLine <> 8 THEN Prime' There are 8 vertical dots in tile
  vidTileLine = 0            ' Reset current line within tile
  tileAddr = tileAddr + 16   ' Adjust tileAddr pointer to next text line
  IF tileAddr = $D0 THEN VideoDone ' If we finished the last line then jump to VideoDone

Prime:
  PrimeTileDots              ' setup tile dots for NEXT tile
  GOTO IntDone               ' Do end of video line checks

VideoDone:
  ' Setup for BotBlank
  INC vidMode                ' Set VidMode to BotBlank
  vidCnt = BOT_BORDER        ' Do bottom blank lines 
  GOTO IntDone               ' Do end of video line checks

BotBlank:
  VideoPause                 ' HSync for 5 usec
  AVBlack = 1                ' Video = Black level
  DEC vidCnt
  IF vidCnt <> 0 THEN IntDone' Adjust count and if more jump to end-of-line checks
  ' Done with BotBlank, Setup for VSync
  vidMode = VidMode_VSync    ' Set VidMode to vsync
  vidCnt = 6                 ' vsync lasts for 3 line interrupts

IntDone:
  ' Restore __PARAM1
  ASM
    MOV FSR,#__INTPARAMFSR
    MOV __PARAM1,IND
  ENDASM

RETURNINT 159                ' Repeat every 63.6uSeconds Prescaler = 1:32

'================================================================

Initialize:
  ' Setup video driver and ports
  RA = 0
  RB = 0
  RC = 0
  vidMode = VidMode_VSync
  sndDurCnt = 0
  sndVol = 0
  OPTION = $84               ' Prescaler = 1:32
  GOTO Start

' -------------------------------------------------------------------------
' Subroutine Code
' -------------------------------------------------------------------------

SUB VideoPause
  ASM
    MOV __PARAM1,#75           ' Pause for 4.7uSec
    DJNZ __PARAM1,@$
  ENDASM
ENDSUB


SUB PutTile ' X, Y, TileID or Pos, TileID
  ASM
    JB __PARAMCNT.0,@:Three
    MOV __PARAM3,__PARAM2
    MOV __PARAM2,__PARAM1
    JMP @:GotAddr
:Three
    SWAP __PARAM2
    ADD __PARAM2,__PARAM1
:GotAddr
    ADD __PARAM2,#$20
    MOV W,>>__PARAM2
    AND W,#$0F
    MOV __PARAM4,W
    MOV W,__PARAM2
    AND W,#$E0
    OR W,__PARAM4
    MOV FSR,W
    SETB FSR.4
    JB __PARAM1.0,@:Odd
    SWAP __PARAM3
    AND IND,#$0F
    JMP @:Finish
:Odd
    AND IND,#$F0
:Finish    
    OR IND,__PARAM3
  ENDASM
  BANK
ENDSUB


FUNC GetTile ' X, Y or Pos
  ASM
    JB __PARAMCNT.0,@:GotAddr
    SWAP __PARAM2
    ADD __PARAM1,__PARAM2
:GotAddr
    ADD __PARAM1,#$20
    MOV W,>>__PARAM1
    AND W,#$0F
    MOV __PARAM2,W
    MOV W,__PARAM1
    AND W,#$E0
    OR W,__PARAM2
    OR W,#16
    MOV FSR,W
    MOV __PARAM2,W
    RR __PARAM1 ' Put bit 0 into Carry
    MOV __PARAM1,IND
    SC
    SWAP __PARAM1
    AND __PARAM1,#$0F
  ENDASM
  BANK
  RETURN __PARAM1, __PARAM2
ENDFUNC


SUB Snd ' Tone, Duration
  ASM
    MOV FSR,#sndTone
    MOV IND,__PARAM1
    MOV FSR,#sndDurCnt
    MOV IND,__PARAM2
    SWAP __PARAM3
    MOV FSR,#sndVol
    MOV IND,__PARAM3
    AND AVPort,#$0F
  ENDASM
  BANK
ENDSUB


SUB Delay ' milliseconds
  ASM ' IF __PARAMCNT = 1 THEN __PARAM2 = 0
    DEC __PARAMCNT
    SNZ
    CLR __PARAM2
    INC __PARAM2
:Next
    MOV __PARAM3,#16
:Again
    SETB intFlag
:Wait
    SNB intFlag
    JMP :Wait
    DJNZ __PARAM3,@:Again
    DJNZ __PARAM1,@:Next
    DJNZ __PARAM2,@:Next
  ENDASM
ENDSUB


SUB WaitSync
  ASM
    MOV FSR,#vidMode
    CJNE IND,#VidMode_BBlank,@$
    CJE IND,#VidMode_BBlank,@$
  ENDASM
  BANK
ENDSUB


ADDRESS $1FF
'  NOP		' Error if code exceeds allowed size

'{$IFDEF LOAD_PIXEL_TILESET_1}
ADDRESS $200
  ' Tile patterns for line 0 or all lines if TILE_SETS_1 is defined
  ' 1 4
  ' 2 8
  DATA $00,$00,$00,$00,$00,$00,$00,$00
  DATA $F0,$F0,$F0,$F0,$00,$00,$00,$00
  DATA $00,$00,$00,$00,$F0,$F0,$F0,$F0
  DATA $F0,$F0,$F0,$F0,$F0,$F0,$F0,$F0
  DATA $0F,$0F,$0F,$0F,$00,$00,$00,$00
  DATA $FF,$FF,$FF,$FF,$00,$00,$00,$00
  DATA $0F,$0F,$0F,$0F,$F0,$F0,$F0,$F0
  DATA $FF,$FF,$FF,$FF,$F0,$F0,$F0,$F0
  DATA $00,$00,$00,$00,$0F,$0F,$0F,$0F
  DATA $F0,$F0,$F0,$F0,$0F,$0F,$0F,$0F
  DATA $00,$00,$00,$00,$FF,$FF,$FF,$FF
  DATA $F0,$F0,$F0,$F0,$FF,$FF,$FF,$FF
  DATA $0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F
  DATA $FF,$FF,$FF,$FF,$0F,$0F,$0F,$0F
  DATA $0F,$0F,$0F,$0F,$FF,$FF,$FF,$FF
  DATA $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
'{$ENDIF}


'{$IFDEF LOAD_PIXEL_TILESET_2}
ADDRESS $280
  ' TILE PATTERNS FOR LINES 1 THRU 10
  ' 1 4
  ' 2 8
  DATA $00,$00,$00,$00,$00,$00,$00,$00
  DATA $F0,$F0,$F0,$F0,$00,$00,$00,$00
  DATA $00,$00,$00,$00,$F0,$F0,$F0,$F0
  DATA $F0,$F0,$F0,$F0,$F0,$F0,$F0,$F0
  DATA $0F,$0F,$0F,$0F,$00,$00,$00,$00
  DATA $FF,$FF,$FF,$FF,$00,$00,$00,$00
  DATA $0F,$0F,$0F,$0F,$F0,$F0,$F0,$F0
  DATA $FF,$FF,$FF,$FF,$F0,$F0,$F0,$F0
  DATA $00,$00,$00,$00,$0F,$0F,$0F,$0F
  DATA $F0,$F0,$F0,$F0,$0F,$0F,$0F,$0F
  DATA $00,$00,$00,$00,$FF,$FF,$FF,$FF
  DATA $F0,$F0,$F0,$F0,$FF,$FF,$FF,$FF
  DATA $0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F
  DATA $FF,$FF,$FF,$FF,$0F,$0F,$0F,$0F
  DATA $0F,$0F,$0F,$0F,$FF,$FF,$FF,$FF
  DATA $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
'{$ENDIF}


'{$IFDEF TILESETS_1}
ADDRESS $280    ' User program resides from $280 to $7FE when only 1 bitmap set is used
'{$ELSE}
ADDRESS $300	' User program resides from $300 to $7FE when two bitmap sets are used
'{$ENDIF}


'{$IFDEF LOAD_LINEADDR}
FUNC LineAddr
  ASM
    SWAP __PARAM1
    CLC
    RL __PARAM1
    ADD __PARAM1,#$30
  ENDASM
  RETURN __PARAM1
ENDFUNC
'{$ENDIF}

'{$IFDEF LOAD_CLEARSCREEN}
SUB ClearScreen ' TileID, StartLine
  ASM
    MOV W,__PARAM1
    SWAP __PARAM1
    OR __PARAM1,W
    SNB __PARAMCNT.0
    CLR __PARAM2
    SWAP __PARAM2
    ADD __PARAM2,#$20
    MOV W,>>__PARAM2
    AND W,#$0F
    MOV __PARAM4,W
    MOV W,__PARAM2
    AND W,#$E0
    OR W,__PARAM4
    MOV FSR,W
    SETB FSR.4
:Fill
    MOV IND,__PARAM1
    INC FSR
    SETB FSR.4 
   CJNE FSR,#$D8,@:Fill
  ENDASM
  BANK
ENDSUB
'{$ENDIF}


'{$IFDEF LOAD_SCROLLUP}
SUB ScrollUp
  ASM
    MOV FSR,#$50
:NextLine
    MOV __PARAM3,#8
:MoveLine
    MOV __PARAM2,IND
    MOV W,#$08
    SB FSR.3
    MOV W,#$18
    SUB FSR,W
    MOV IND,__PARAM2
    MOV W,#$09
    SNB FSR.3
    MOV W,#$19
    ADD FSR,W
    DJNZ __PARAM3, @:MoveLine
    SETB FSR.4
    CJNE FSR,#$D8,@:NextLine
    ' Clear bottom line
    MOV FSR,#$D0
    JNB __PARAMCNT.0,@:Done
    MOV __PARAM3,#8
    MOV W,<>__PARAM1
    OR W,__PARAM1
:BlankBot
    MOV IND,W
    INC FSR
    DJNZ __PARAM3,@:BlankBot
:Done
  ENDASM  
  BANK
ENDSUB
'{$ENDIF}


'{$IFDEF LOAD_SCROLLDOWN}
SUB ScrollDown
  ASM
    MOV FSR,#$BF
:NextLine
    MOV __PARAM3,#8
:MoveLine
    MOV __PARAM2,IND
    MOV W,#$08
    SNB FSR.3
    MOV W,#$18
    ADD FSR,W
    MOV IND,__PARAM2
    MOV W,#$09
    SB FSR.3
    MOV W,#$19
    SUB FSR,W
    DJNZ __PARAM3, @:MoveLine
    MOV W,#$10
    SB FSR.4
    SUB FSR,W
    CJNE FSR,#$37,@:NextLine
    JNB __PARAMCNT.0,@:Done
    ' Clear top line
    MOV FSR,#$38
    MOV __PARAM3,#8
    MOV W,<>__PARAM1
    OR W,__PARAM1
:BlankTop
    MOV IND,W
    INC FSR
    DJNZ __PARAM3,@:BlankTop
:Done
  ENDASM
  BANK
ENDSUB
'{$ENDIF}


'{$IFDEF LOAD_SCROLLLEFT}
SUB ScrollLeft
  ASM
    SWAP __PARAM1 ' Get tile value in high nibble
    MOV FSR,#$3F
:NextLine
    MOV __PARAM2,#4 ' Shift 4 bits to the left
:Again
    MOV __PARAM3,#8 ' Eight bytes per line
    RL __PARAM1
:ShiftLine
    RL IND
    DEC FSR
    DJNZ __PARAM3,@:ShiftLine
    ADD FSR,#$08
    DJNZ __PARAM2,@:Again
    ADD FSR,#$08
    SETB FSR.4
    CJNE FSR,#$DF,@:NextLine
  ENDASM
  BANK
ENDSUB
'{$ENDIF}


'{$IFDEF LOAD_SCROLLRIGHT}
SUB ScrollRight
  ASM
    MOV FSR,#$38
:NextLine
    MOV __PARAM1,#4 ' Shift 4 bits to the left
:Again
    MOV __PARAM2,#8 ' Eight bytes per line
    RR __PARAM1
:ShiftLine
    RR IND
    INC FSR
    DJNZ __PARAM2,@:ShiftLine
    SUB FSR,#$08
    DJNZ __PARAM1,@:Again
    ADD FSR,#$08
    SETB FSR.4
    CJNE FSR,#$D8,@:NextLine
  ENDASM
  BANK  
ENDSUB
'{$ENDIF}


'{$IFDEF LOAD_VALUEINC}
SUB ValueInc ' Position
  ASM
    CLC
    MOV W,>>__PARAM1
    MOV FSR,W
    ADD FSR,#$30
    JB __PARAM1.0,@:Odd
    ADD IND,#$10
    MOV __PARAM2,IND
    AND __PARAM2,#$F0
    CJNE __PARAM2,#$A0,@:Done
    AND IND,#$0F
    SUB __PARAM1,#1
    JC @ValueInc
    JMP @:Done
:Odd
    INC IND
    MOV __PARAM2,IND
    AND __PARAM2,#$0F
    CJNE __PARAM2,#$0A,@:Done
    AND IND,#$F0
    DEC __PARAM1
    JMP @ValueInc 
:Done
  ENDASM
  BANK
ENDSUB
'{$ENDIF}


'{$IFDEF LOAD_VALUEDEC}
SUB ValueDec ' Position (NEED CHANGED)
  ASM
    CLC
    MOV W,>>__PARAM1
    MOV FSR,W
    ADD FSR,#$30
    JB __PARAM1.0,@:Odd
    SUB IND,#$10
    MOV __PARAM2,IND
    AND __PARAM2,#$F0
    CJNE __PARAM2,#$A0,@:Done
    AND IND,#$0F
    SUB __PARAM1,#1
    JC @ValueDec
    JMP @:Done
:Odd
    DEC IND
    MOV __PARAM2,IND
    AND __PARAM2,#$0F
    CJNE __PARAM2,#$0A,@:Done
    AND IND,#$F0
    DEC __PARAM1
    JMP @ValueDec
:Done
  ENDASM
  BANK
ENDSUB
'{$ENDIF}


'{$IFDEF LOAD_PLOTXY}
SUB PlotXY
  ASM
    MOV __PARAM3,#1
    MOV W,#16
    SB __PARAM1.1
    MOV __PARAM3,W

    CLC
    SNB __PARAM1.0
    RL __PARAM3
    CLC ' ???
    SNB __PARAM1.0
    RL __PARAM3
    CLC ' ???
    SNB __PARAM2.0
    RL __PARAM3

    CLC ' ???
    RR __PARAM1
    CLC
    RR __PARAM2
  ENDASM
  GetTile __PARAM1, __PARAM2 ' Returns with tile value in __PARAM1 and tile address in __PARAM2
  ASM
    MOV FSR,__PARAM2
    OR IND,__PARAM3
  ENDASM
  BANK
ENDSUB
'{$ENDIF}


'{$IFDEF LOAD_UNPLOTXY}
SUB UnPlotXY
  ASM
    MOV __PARAM3,#1
    MOV W,#16
    SB __PARAM1.1
    MOV __PARAM3,W

    CLC
    SNB __PARAM1.0
    RL __PARAM3
    CLC ' ???
    SNB __PARAM1.0
    RL __PARAM3
    CLC ' ???
    SNB __PARAM2.0
    RL __PARAM3

    CLC ' ???
    RR __PARAM1
    CLC
    RR __PARAM2
  ENDASM
  GetTile __PARAM1, __PARAM2 ' Returns with tile value in __PARAM1 and tile address in __PARAM2
  ASM
    NOT __PARAM3
    MOV FSR,__PARAM2
    AND IND,__PARAM3
  ENDASM
  BANK
ENDSUB
'{$ENDIF}


' **** END OF INCLUDE ****

